{
   ਭ  BMP
}
unit WriteBMP;
{----------------------------}
         interface
{----------------------------}

procedure WriteBMPFile(x1, y1, x2, y2:integer; FileName:string);

{----------------------------}
       implementation
{----------------------------}
uses
  Graph;

type
  TBMPHeader=record
    bfType: array[0..1] of char;
    bfSize: longint;
    bfReserved: longint;
    bfOffbits: longint;
    biSize: longint;
    biWidth: longint;
    biHeight: longint;
    biPlanes: word;
    biBitCount: word;
    biCompression: longint;
    biSizeImage: longint;
    biXPelsPerMeter: longint;
    biYPelPerMeter: longint;
    biClrUsed: longint;
    biClrImportant: longint;
  end;

  RGB=record
    Red, Green, Blue, Reserved: byte;
  end;

const
  Header: TBMPHeader=(
    bfType: 'BM';
    bfSize: 0;
    bfReserved: 0;
    bfOffbits: 1078;
    biSize: 40;
    biWidth: 0;
    biHeight: 0;
    biPlanes: 1;
    biBitCount: 8;
    biCompression: 0;
    biSizeImage: 0;
    biXPelsPerMeter: 0;
    biYPelPerMeter: 0;
    biClrUsed: 0;
    biClrImportant: 0);

var
  BMPFile: file;
  Buffer: array[0..799] of byte;

procedure WritePalette;
var
  Palette: array[0..255] of RGB;
  i, R, G, B: byte;

begin
  for i:=0 to 255 do
  begin
    asm
      mov dx, 03C7h
      mov al, i
      out dx, al
      inc dx
      inc dx
      in al, dx
      mov B, al
      in al, dx
      mov G, al
      in al, dx
      mov R, al
    end;
    Palette[i].Red:=R*4;
    Palette[i].Green:=G*4;
    Palette[i].Blue:=B*4;
    Palette[i].Reserved:=0;
  end;
  BlockWrite(BMPFile, Palette, SizeOf(Palette));
end;

procedure WriteBMPFile(x1, y1, x2, y2:integer; FileName:string);
var
  StrSize: longint;
  Ost: byte;
  x, y: integer;

begin
  Assign(BMPFile, FileName);
  Rewrite(BMPFile, 1);
  Header.biWidth:=x2-x1+1;
  Header.biHeight:=y2-y1+1;
  if (Header.biWidth mod 4)<>0 then
  begin
    StrSize:=(Header.biWidth div 4)*4+4;
    Ost:=StrSize-Header.biWidth;
  end
  else
  begin
    StrSize:=Header.biWidth;
    Ost:=0;
  end;
  Header.biSizeImage:=StrSize*Header.biHeight;
  Header.bfSize:=1078+Header.biSizeImage;
  BlockWrite(BMPFile, Header, SizeOf(Header));
  WritePalette;
  for y:=y2 downto y1 do
  begin
    for x:=x1 to x2 do
      Buffer[x-x1]:=GetPixel(x, y);
    for x:=x2-x1+1 to x2-x1+Ost do
      Buffer[x]:=0;
    BlockWrite(BMPFile, Buffer, StrSize);
  end;
  Close(BMPFile);
end;

end.